<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="点位名称" prop="pointName">
        <el-input
          v-model="queryParams.pointName"
          placeholder="请输入点位名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="监测名称" prop="items">
        <el-input
          v-model="queryParams.items"
          placeholder="请输入监测项名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="监测时间" prop="time">
        <el-date-picker
          clearable
          v-model="time"
          type="datetimerange"
          value-format="yyyy-MM-dd HH:mm:ss"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          @change="searchDate"
          :editable="false"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>
    <!-- 
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:data:export']"
          >导出</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row> -->

    <el-table
      v-loading="loading"
      :data="dataList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column label="点位名称" align="center" prop="pointName" />
      <el-table-column label="监测名称" align="center" prop="items" />
      <el-table-column label="监测值" align="center" prop="evalue" />
      <el-table-column label="监测时间" align="center" prop="time" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.time, "{y}-{m}-{d} {h}:{m}:{s}") }}</span>
        </template>
      </el-table-column>
      <el-table-column label="报警状态" align="center" prop="status">
        <template slot-scope="scope">
          <span v-if="scope.row.status == 0" style="color: #67c23a">正常</span>
          <span v-if="scope.row.status == 1" style="color: #f56c6c">报警</span>
        </template>
      </el-table-column>
      <el-table-column label="报警级别" align="center" prop="alarmlevel">
        <template slot-scope="scope">
          <span v-if="scope.row.alarmlevel == 1" style="color: #fa0606"
            >一级报警</span
          >
          <span v-if="scope.row.alarmlevel == 2" style="color: #fc5004"
            >二级报警</span
          >
          <span v-if="scope.row.alarmlevel == 3" style="color: #98992b"
            >三级报警</span
          >
          <span v-if="scope.row.alarmlevel == 4" style="color: #0533fc"
            >四级报警</span
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改环境监测历史信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="点位名称" prop="pointName">
          <el-input v-model="form.pointName" placeholder="请输入点位名称" />
        </el-form-item>
        <el-form-item label="监测名称" prop="items">
          <el-input v-model="form.items" placeholder="请输入监测项名称" />
        </el-form-item>
        <el-form-item label="监测值" prop="evalue">
          <el-input v-model="form.evalue" placeholder="请输入监测值" />
        </el-form-item>
        <el-form-item label="监测时间" prop="time">
          <el-date-picker
            clearable
            v-model="form.time"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="请选择监测时间"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="报警级别" prop="alarmlevel">
          <el-input v-model="form.alarmlevel" placeholder="请输入报警级别" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listData,
  getData,
  delData,
  addData,
  updateData,
} from "@/api/envi/waterhis";

export default {
  name: "Data",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 环境监测历史信息表格数据
      dataList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        pointName: null,
        monitorType: "水质监测",
        items: null,
        evalue: null,
        time: null,
        status: null,
        alarmlevel: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      time: null,
    };
  },
  created() {
    this.getList();
  },
  methods: {
    stateChange(e) {
      console.log(e);
      if (!e) {
        this.queryParams.state = null;
      } else {
        this.queryParams.state = e;
      }
    },
    searchDate(e) {
      if (!e) {
        this.queryParams.beginTime = null;
        this.queryParams.endTime = null;
      } else {
        this.queryParams.beginTime = e[0];
        this.queryParams.endTime = e[1];
      }
    },
    /** 查询环境监测历史信息列表 */
    getList() {
      console.log(this.queryParams);
      this.loading = true;
      listData(this.queryParams).then((response) => {
        this.dataList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        pointName: null,
        monitorType: "水质监测",
        items: null,
        evalue: null,
        time: null,
        status: 0,
        alarmlevel: null,
        createTime: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加环境监测历史信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getData(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改环境监测历史信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateData(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addData(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除环境监测历史信息编号为"' + ids + '"的数据项？')
        .then(function () {
          return delData(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "system/data/export",
        {
          ...this.queryParams,
        },
        `data_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
